Program Turingmaschine;

uses crt;

const max_zei = 20;
      max_zust = 99;
      max_lan = 1000;

type bandalph = array[0..max_zei] of char;

     turingtafeleintrag= record
                           ausgabe: char;
                           folgezust: byte;
                           kopf: char;
                         end;

     turingtafel= array[0..max_zei,0..max_zust] of turingtafeleintrag;
     band = array[1..max_lan] of char;

var alph: bandalph;
    tt: turingtafel;
    eb,ab: band;
    stelle: integer;

    alphabet: set of char;


procedure ini;
var i,j: integer;
begin
  for i:= 0 to max_zei do
  begin
    alph[i]:= ' ';
    for j:= 0 to max_zust do
    begin
      tt[i,j].ausgabe:= ' ';
      tt[i,j].folgezust:= 0;
      tt[i,j].kopf:= '-';
    end;
  end;
  for i:= 1 to max_lan do begin eb[i]:= ' '; ab[i]:= ' '; end;
  stelle:= 0;

  alphabet:= [];
  for i:= 0 to max_zei do alphabet:= alphabet+ [alph[i]];
  alphabet:= alphabet-[' '];

end;


procedure einlesen(dname:string);
var i, j: integer;
    datei: text;
    z:string;
    zust,zei:byte;
    code: integer;
begin
  assign(datei,dname+'.tur');

{$I-}
  reset(datei);
  if ioresult=0 then
  begin
    readln(datei,z);
    i:= 0;
    repeat inc(i); until z[i]='"';
    inc(i);
    j:= 0;
    while z[i]<>'"' do
    begin
      alph[j]:= z[i];
      inc(i);
      inc(j);
    end;

    for i:= 1 to max_lan do begin eb[i]:= alph[0]; end;

    readln(datei,z);
    i:= 0;
    repeat inc(i) until z[i]='=';
    val(copy(z,i+1,length(z)),stelle,code);
    readln(datei,z);
    i:= 0;
    repeat inc(i); until z[i]='"';
    inc(i);
    j:= 0;
    while z[i]<>'"' do
    begin
      eb[j+stelle]:= z[i];
      inc(j); inc(i);
    end;

    zust:= 0;
    while not eof(datei) do
    begin
      readln(datei,z);
      val(copy(z,1,2),zust,code);
      i:= 0;
      zei:= 0;
      while i<length(z) do
      begin
        while (i<length(z)) and (z[i]<>'(') do inc(i);
        if i<length(z) then
        begin
          repeat inc(i); until z[i]='"';
          inc(i);
          tt[zei,zust].ausgabe:= z[i];
          repeat inc(i); until z[i]=',';
          inc(i);
          val(copy(z,i,2),tt[zei,zust].folgezust,code);
          repeat inc(i); until z[i]=',';
          inc(i);
          tt[zei,zust].kopf:= z[i];
          inc(zei);
        end;
      end;
      inc(zust);
    end;

    for i:= 0 to max_zei do alphabet:= alphabet+ [alph[i]];
    alphabet:= alphabet-[' '];

    close(datei);
  end;

  {$I+}
end;



procedure auslesen(dname:string);
var i, j: integer;
    datei: text;
    z:string;
    zust,zei:byte;
    code: integer;
begin
  assign(datei,dname+'.tur');

{$I-}
  rewrite(datei);
  if ioresult=0 then
  begin

    write(datei,'Alphabet= "');
    for i:= 0 to max_zei do write(datei,alph[i]);
    writeln(datei,'"');
    writeln(datei,'Stelle= ',stelle);
    write(datei,'Eingabe= "');
    i:= max_lan;
    while eb[i]=alph[0] do dec(i);
    for j:= stelle to i do write(datei,eb[j]);
    writeln(datei,'"');
    writeln(datei,'Tabelle');
    for i:= 0 to max_zei do if alph[i]<>' ' then write(datei,'      "'+alph[i]+'"  ');
    writeln(datei,' ');
    for j:= 0 to max_zust do 
    begin
      write(datei,j:2,' ');
      for i:= 0 to max_zei do
      begin
        if alph[i]<>' ' then
        begin
          write(datei,'("'+tt[i,j].ausgabe+'",',tt[i,j].folgezust:2,',',tt[i,j].kopf,') ');
        end;
      end;
      writeln(datei,' ');
    end;

    close(datei);
  end;

  {$I+}
end;




procedure turingeingabe;
var zust,zei,x,y: integer;
    x2: integer;
    feldakt: integer;

procedure bandausgabe;
var i: integer;
begin
  for i:= 1 to 79 do
  begin
    if zust=-2 then begin textcolor(black); textbackground(lightgray); end;
    gotoxy(i,24);
    write(eb[x2+i]);
    textcolor(lightgray); textbackground(black);

    gotoxy(i,25);
    if x2+i=feldakt then write('^')
                   else write(' ');

    gotoxy(i,21); write(' ');
    gotoxy(i,22); write(' ');
    gotoxy(i,23); write(' ');
    if (x2+i) mod 5=0 then
    begin
      gotoxy(i,21); if x2+i>=100 then write(((x2+i) mod 1000) div 100);
      gotoxy(i,22); if x2+i>=10 then write(((x2+i) mod 100) div 10);
      gotoxy(i,23); write((x2+i) mod 10);
    end;

  end;
  gotoxy(1,1);

end;

procedure tabellenausgabe;
var i,j: integer;
begin
  gotoxy(1,1);
  textcolor(lightgray); textbackground(black);

  write('           ');
  for i:= x to x+3 do
  begin
    if (zei=i) and (zust=-1) then begin textcolor(black); textbackground(lightgray); end;
    if (i>max_zei) or (alph[i]=' ') then write('          ')
                 else write('    "'+alph[i]+'"   ');
    textcolor(lightgray); textbackground(black);
    write('');
  end;
  writeln;
  for j:= y to y+3 do
  begin
    write('');
    for i:= 1 to 5 do begin write('');if i<5 then write('') else write(''); end;
    writeln;
    write('           ');
    for i:= x to x+3 do
    begin
      if (zei=i) and (zust=j) then begin textcolor(black); textbackground(lightgray); end;
      if (i>max_zei) or (j> max_zust) or (tt[i,j].kopf='-') then write('          ')
                                  else write(' Write: '+tt[i,j].ausgabe+' ');
      textcolor(lightgray); textbackground(black);
      write('');
    end;
    writeln;
    if j>max_zust then write('           ')
                  else write('Zustand: ',j:2,'');
    for i:= x to x+3 do
    begin
      if (zei=i) and (zust=j) then begin textcolor(black); textbackground(lightgray); end;
      if (i>max_zei) or (j> max_zust) or (tt[i,j].kopf='-') then write('          ')
                                  else write(' Next: ',tt[i,j].folgezust:2,' ');
      textcolor(lightgray); textbackground(black);
      write('');
    end;
    writeln;
    write('           ');
    for i:= x to x+3 do
    begin
      if (zei=i) and (zust=j) then begin textcolor(black); textbackground(lightgray); end;
      if (i>max_zei) or (j> max_zust) or (tt[i,j].kopf='-') then write('          ')
                                  else write(' Move:  '+tt[i,j].kopf+' ');
      textcolor(lightgray); textbackground(black);
      write('');
    end;
    writeln;
  end;
  write('');
  for i:= 1 to 5 do begin write('');if i<5 then write('') else write(''); end;
  writeln;

  gotoxy(1,1);
end;


procedure turingausgabe;
var anzzust: byte;
    zustakt: byte;
    zeiakt: byte;

    fehler: byte;
    beendet: boolean;
    t1, t2: char;
    i: integer;
    einzelschritt: boolean;

begin

  for i:= 1 to max_lan do ab[i]:= eb[i];
  clrscr;
  bandausgabe;

  gotoxy(1,1); clreol;
  write('<S>: Einzelschritt  <SPACE>: Schnelldurchlauf  <ESC>: Abbruch');
  zustakt:= 0;
  fehler:= 0;
  beendet:= false;
  einzelschritt:= true;

  repeat

    zeiakt:= 0;
    while alph[zeiakt]<> eb[feldakt] do inc(zeiakt);
    gotoxy(1,3); clreol;
    gotoxy(1,3); write('Zustand: ',zustakt:2,', Zeichen: ',alph[zeiakt],'  =>  Zustand: ',tt[zeiakt,zustakt].folgezust:2);
    write(', Schreibe ein: ',tt[zeiakt,zustakt].ausgabe,', und laufe ');
    case tt[zeiakt,zustakt].kopf of
      'L': write('nach links');
      'R': write('nach rechts');
      'N': write('gar nicht');
    end;
    if tt[zeiakt,zustakt].kopf = '-' then fehler:= 1;

    if einzelschritt then
    begin
      repeat t1:= readkey; until t1 in [#27,'s','S',#32];
      if t1= #32 then einzelschritt:= false;
    end
    else begin
      if keypressed then
      begin
        t1:= readkey;
        if upcase(t1)='S' then einzelschritt:= true;
      end;
    end;

    if (zustakt=tt[zeiakt,zustakt].folgezust)
      and (eb[feldakt]=tt[zeiakt,zustakt].ausgabe)
      and (tt[zeiakt,zustakt].kopf='N') then beendet:= true;

    eb[feldakt]:= tt[zeiakt,zustakt].ausgabe;
    case tt[zeiakt,zustakt].kopf of
      'L': begin
             if feldakt>1 then dec(feldakt)
                          else fehler:= 2;
             if feldakt<= x2 then dec(x2);
           end;
      'R': begin
             if feldakt<max_lan then inc(feldakt)
                                else fehler:= 2;
             if feldakt>= x2+80 then inc(x2);
           end;
    end;

    zustakt:= tt[zeiakt,zustakt].folgezust;

    bandausgabe;


  until (t1=#27) or (fehler>0) or beendet;

  gotoxy(1,5);
  if fehler=1 then write('Es ist ein Fehler aufgetreten! (Turingtabelleneintrag existiert nicht)');
  if fehler=2 then write('Es ist ein Fehler aufgetreten! (Unser Band ist leider nur endlich)');
  if beendet then write('Das Programm ist erfolgreich in eine Endlosschleife geraten!');
  if t1=#27 then write('Das Programm wurde vom Benutzer abgebrochen!');

  gotoxy(10,7);
  write('<ENTER> um zur Programmeingabe zu gelangen');
  repeat t2:= readkey; until t2=#13;

  for i:= 1 to max_lan do eb[i]:= ab[i];

end;



var t1, t2: char;
    n: byte;
    i,j: integer;
    altzust: integer;
    dname: string;
    anzahl: integer;

begin
  clrscr;
  zust:= 0; zei:= 0;
  x:= 0; y:= 0;
  n:= 0;
  feldakt:= stelle;
  if feldakt>40 then x2:= feldakt-40
                else x2:= 0;

  repeat

    gotoxy(57,1); write('<ESC>  : ENDE           ');
    gotoxy(57,2); write('<ENTER>: Eintrag ndern ');
    gotoxy(57,3); write('<DEL>  : Eintrag lschen');
    gotoxy(57,4); write('<TAB>  : Eingabeband    ');
    gotoxy(57,6); write('<R>    : Prgm starten   ');
    gotoxy(57,7); write('<L>    : Prgm laden     ');
    gotoxy(57,8); write('<S>    : Prgm speichern ');
    gotoxy(57,9); write('<N>    : Prgm neu       ');

    tabellenausgabe;
    bandausgabe;

    repeat until keypressed;
    t1:= readkey;
    case t1 of
      #00: begin
             t2:= readkey;
             case t2 of
               'H':begin
                     if zust>=0 then dec (zust);
                     if (zust< y) and (zust>=0) then dec(y);
                   end;
               'K':begin
                     if zei>0 then dec (zei);
                     if zei<x then dec(x);
                   end;
               'P':begin
                     if zust<max_zust then inc (zust);
                     if zust> y+3 then inc(y);
                   end;
               'M':begin
                     if zei<max_zei then inc (zei);
                     if zei>x+3 then inc(x);
                   end;
               'S':begin
                     if zust>=0 then
                     begin
                       tt[zei,zust].ausgabe:= ' ';
                       tt[zei,zust].folgezust:= 0;
                       tt[zei,zust].kopf:= '-';
                     end
                     else begin
                       for i:= 0 to max_zei do for j:= 0 to max_zust do
                       begin
                         if (tt[i,j].ausgabe=alph[zei]) or (i=zei) then
                         begin
                           tt[i,j].ausgabe:= ' ';
                           tt[i,j].folgezust:= 0;
                           tt[i,j].kopf:= '-';
                         end;
                       end;
                       for i:= 1 to max_lan do if eb[i]=alph[zei] then eb[i]:= ' ';
                       alph[zei]:= ' ';

                     end;
                   end;
             end;
           end;
      #13: begin
             if zust>=0 then
             begin
               textcolor(black); textbackground(lightgray);
               gotoxy((zei-x)*11+14,(zust-y)*4+3);
               write('Write: ');
               t2:= tt[zei,zust].ausgabe;
               repeat t2:= upcase(readkey) until (t2 in alphabet) or (t2=#13);
               if t2<>#13 then tt[zei,zust].ausgabe:= t2;
               write (tt[zei,zust].ausgabe);
               n:= tt[zei,zust].folgezust;
               repeat
                 gotoxy((zei-x)*11+14,(zust-y)*4+4);
                 write('Next: ',n:2);
                 gotoxy((zei-x)*11+21,(zust-y)*4+4);
                 repeat until keypressed;
                 t2:= readkey;
                 case t2 of
                   'H','K': if n>0 then dec(n);
                   'M','P': if n<max_zust then inc(n);
                 end;
               until t2=#13;
               tt[zei,zust].folgezust:= n;
               gotoxy((zei-x)*11+14,(zust-y)*4+5);
               write('Move:  ');
               t2:= tt[zei,zust].kopf;
               repeat t2:= upcase(readkey) until t2 in ['L','R','N',#13];
               if t2<>#13 then tt[zei,zust].kopf:= t2;
               write (tt[zei,zust].kopf);
             end
             else begin
               textcolor(black); textbackground(lightgray);
               gotoxy((zei-x)*11+17,1);
               write('"',alph[zei],'"');
               gotoxy((zei-x)*11+18,1);
               t2:= alph[zei];
               repeat
                 t2:= upcase(readkey)
               until (t2 in ['A'..'Z','0'..'9','*','#','-','+','=','_']-alphabet+[alph[zei]]) or (t2=#13);
               if t2=#13 then t2:= alph[zei];
               for i:= 0 to max_zei do for j:= 0 to max_zust do
               begin
                 if tt[i,j].ausgabe=alph[zei] then tt[i,j].ausgabe:= t2;
               end;
               for i:= 1 to max_lan do if eb[i]=alph[zei] then eb[i]:= t2;

               alph[zei]:= t2;

             end;
             textcolor(lightgray); textbackground(black);

           end;
      #09: begin
             gotoxy(57,1); write('<CRSR> : links/rechts   ');
             gotoxy(57,2); write('<PgUp> : schnell links  ');
             gotoxy(57,3); write('<PgDwn>: schnell rechts ');
             gotoxy(57,4); write('<TAB>  : Turingtabelle  ');
             gotoxy(57,6); clreol;
             gotoxy(57,7); clreol;
             gotoxy(57,8); clreol;
             gotoxy(57,9); clreol;

             altzust:= zust;
             zust:= -2;
             tabellenausgabe;
             bandausgabe;
             repeat
               repeat until keypressed;
               t1:= readkey;
               case t1 of
                 #00: begin
                        t2:= readkey;
                        case t2 of
                          'K': begin
                                 if feldakt>1 then dec(feldakt);
                                 if feldakt<= x2 then dec(x2);
                               end;
                          'M': begin
                                 if feldakt<max_lan then inc(feldakt);
                                 if feldakt>= x2+80 then inc(x2);
                               end;
                          'I': begin
                                 if feldakt>10 then feldakt:= feldakt-10;
                                 if feldakt<=x2 then x2:= x2-10;
                               end;
                          'Q': begin
                                 if feldakt<max_lan-10 then feldakt:= feldakt+10;
                                 if feldakt>= x2+80 then x2:= x2+10;
                               end;
                        end;
                      end;
               end;
               if t1 in alphabet then begin
                 eb[feldakt]:= t1;
                 if feldakt<max_lan then inc(feldakt);
                 if feldakt>= x2+80 then inc(x2);
               end;

               bandausgabe;
             until (t1=#09) or (t1=#27);
             stelle:= 1; while eb[stelle]=alph[0] do inc(stelle);
             if stelle>=1000 then stelle:= 40;
             zust:= altzust;
             bandausgabe;
           end;
      'z','Z': begin
             gotoxy(57,10);
             write('Wirklich Zufall?');
             repeat t1:= upcase(readkey); until t1 in ['J','N'];
             if t1='J' then
             begin
               gotoxy(57,10);
               write('Wieviel Zustnde: '); readln(anzahl);
               for j:= 0 to max_zust do for i:= 0 to max_zei do
               begin
                 tt[i,j].kopf:= '-';
                 tt[i,j].ausgabe:= ' ';
                 tt[i,j].folgezust:= 0;
                 if (alph[i]<>' ') and (j<anzahl) then
                 begin
                   t1:= ' '; while t1=' ' do t1:= alph[random(max_zei+1)];
                   tt[i,j].ausgabe:= t1;
                   tt[i,j].folgezust:= random(anzahl);
                   case random(3) of
                     0: tt[i,j].kopf:= 'N';
                     1: tt[i,j].kopf:= 'L';
                     2: tt[i,j].kopf:= 'R';
                   end;
                 end;
               end;
               tabellenausgabe;
             end;
           end;
      'r','R': begin
             turingausgabe;
             feldakt:= stelle;
             if feldakt>40 then x2:= feldakt-40
                           else x2:= 0;
             clrscr;
             bandausgabe;
             tabellenausgabe;
           end;
      'l','L': begin
             gotoxy(57,10);
             write('Wirklich laden?');
             repeat t1:= upcase(readkey); until t1 in ['J','N'];
             if t1='J' then
             begin
               gotoxy(57,10); clreol;
               write('Dateiname: '); readln(dname);
               if dname<> '' then
               begin
                 ini;
                 einlesen(dname);
                 feldakt:= stelle;
                 if feldakt>40 then x2:= feldakt-40
                               else x2:= 0;
               end;
             end;
             gotoxy(57,10); clreol;
             bandausgabe;
             tabellenausgabe;
           end;
      'n','N': begin
             gotoxy(57,10);
             write('Wirklich Neues Prgm?');
             repeat t1:= upcase(readkey); until t1 in ['J','N'];
             if t1='J' then
             begin
               ini;
               feldakt:= stelle;
               if feldakt>40 then x2:= feldakt-40
                             else x2:= 0;
             end;
             gotoxy(57,10); clreol;
             bandausgabe;
             tabellenausgabe;
           end;
      's','S': begin
             gotoxy(57,10);
             write('Wirklich speichern?');
             repeat t1:= upcase(readkey); until t1 in ['J','N'];
             if t1='J' then
             begin
               gotoxy(57,10); clreol;
               write('Dateiname: '); readln(dname);
               if dname<> '' then auslesen(dname);
             end;
             gotoxy(57,10); clreol;
           end;
    end;
    alphabet:= [];
    for i:= 0 to max_zei do alphabet:= alphabet+ [alph[i]];
    alphabet:= alphabet-[' '];

  until t1=#27;
  tabellenausgabe;
  bandausgabe;

end;




begin
  randomize;
  ini;
  turingeingabe;
end.